#define _LEGACY_HEADERS

#include <htc.h>
#include <pic16f886.h>
#include "hitec_c_i2c.h"
#include "lcd_sub.h"
#include "port_init.h"
#include "wait_time.h"

__CONFIG(	DEBUGDIS & LVPDIS & FCMDIS & IESODIS & BORDIS
			& DUNPROTECT & UNPROTECT & MCLREN & PWRTEN & WDTDIS & INTIO);
__CONFIG(	0xffff & BORV21);

#define		_XTAL_FREQ				4000000

unsigned char	i2c_ondo_addr=0x48 << 1;
unsigned char	i2c_kiatu_addr=0x5c << 1;

unsigned char	data[2];

unsigned int	ondo_sub;
unsigned long	ondo_keisan;
unsigned char	ondo_hi;
unsigned char	ondo_low;
unsigned char	ondo_fugo;

unsigned char	kiatu_out_xl;
unsigned char	kiatu_out_l;
unsigned char	kiatu_out_h;
unsigned long	kiatu_keisan;

/*---------------------ONDO-----------------------*/
void	ondo_init(void)
{
	data[0]=0x80;
	i2c_data_write(i2c_ondo_addr,0x03,1,data);
}

void	read_ondo(void)
{
	data[0]=0x80 | 0x20;
	i2c_data_write(i2c_ondo_addr,0x03,1,data);	
	__delay_ms(240);

	i2c_data_read(i2c_ondo_addr,0x00,1,data);
	ondo_hi=data[0];
	if((ondo_hi&0x80)==0x80){
		ondo_fugo=1;
	}
	else{
		ondo_fugo=0;
	}
	ondo_hi=ondo_hi & 0x7f;

	i2c_data_read(i2c_ondo_addr,0x01,1,data);
	ondo_low=data[0];

	ondo_sub=(unsigned int)ondo_hi*256+(unsigned int)ondo_low;

	ondo_keisan=((unsigned long)ondo_sub)*78;
	ondo_keisan=ondo_keisan/1000;

}

/*---------------------KIATU----------------------*/
void	kiatu_init(void)
{
	data[0]=0x90;
	i2c_data_write(i2c_kiatu_addr,0x20,1,data);
}
void	read_kiatu(void)
{
	data[0]=0x01;
	while(data[0]==0x00){
		i2c_data_read(i2c_kiatu_addr,0x21,1,data);
	}	
	i2c_data_read(i2c_kiatu_addr,0x28,1,data);
	kiatu_out_xl=data[0];
	i2c_data_read(i2c_kiatu_addr,0x29,1,data);
	kiatu_out_l=data[0];
	i2c_data_read(i2c_kiatu_addr,0x2a,1,data);
	kiatu_out_h=data[0];

	kiatu_keisan=(unsigned long)kiatu_out_h*256*256+(unsigned long)kiatu_out_l*256+(unsigned long)kiatu_out_xl;
	kiatu_keisan=kiatu_keisan*10;
	kiatu_keisan=kiatu_keisan/4096;


}
/*---------------------MAIN-----------------------*/
void	main(void)
{
unsigned char	i;

	port_init();

	__delay_ms(2000);

	I2CInit();	

	lcd_init();
	lcd_clear();

	lcd_xy(0,0);
	lcd_print("      hP");
	lcd_xy(0,1);
	lcd_print("       C");
	lcd_xy(6,1);lcd_data(0xdf);

	ondo_init();
	kiatu_init();


	while(1){

	read_ondo();	
	lcd_xy(1,1);
	lcd_ondo(ondo_fugo,(unsigned int)ondo_keisan);

	read_kiatu();
	lcd_xy(0,0);
	lcd_kiatu((unsigned int)kiatu_keisan);

	__delay_ms(2000);




	}

}